#include <stdio.h>
#include <errno.h>
#include "error.h"
#include "globals.h"

error_t error = E_no_error;

char *error_msg (code)
  error_t code;
{
  switch (code){
  case E_perm: return "maintenance functions are reserved to the owner";
  case E_usage:
    return "usage: murof [-C mblocks nbuckets roX roY] [-D] [-A]";
  case E_nomur: return "you cannot use \"mur\" at the moment";
  case E_cant_open: return "cannot open ";
  case E_std_closed: return "stdin or stdout is closed";
  case E_cant_read: return "cannot read ";
  case E_cant_initialize: return "initialization failed";
  case E_read_only_brick: return "read-only brick";
  case E_unimplemented: return "unimplemented function";
  case E_cant_lock: return "cannot lock brick";
  case E_cant_write: return "cannot write";
  case E_cant_connect: return "cannot connect to ";
  case E_bad_param: return "bad parameter at mur creation";
  case E_server_only: return "this program must be used on ";
  default: return "unknown error";
  }
}

void bug (msg)
  char *msg;
{
  close (misc_fd);
  close (table_fd);
  close (data_fd);

  printf ("fatl 999 internal error: %s.\n", msg);
  exit (99);
}

void fatal (code, msg)
  error_t code;
  char *msg;
{
  message m;

  if (c != NULL){
    sprintf (m.data, "%s%s", error_msg (code), msg);
    m.type = rep_fatl;
    m.x = code;
    mur_write (c, &m);
  }
  fprintf (stderr, "Fatal error %d: %s %s: ", code, error_msg (code), msg);
  if (errno){
    perror ("");
  }else{
    fprintf (stderr, "\n");
  }
  exit (code);
}
