#include <stdio.h>
#include <murlib.h>
#include "globals.h"
#include "io.h"

struct connection *c = NULL;
int log_fd, table_fd, data_fd, misc_fd;
unsigned long info [Info_size];
unsigned long t_read = 0;
unsigned long t_empty = 0;
unsigned long t_written = 0;
unsigned long t_added = 0;
unsigned long t_erased = 0;
unsigned long t_blasted = 0;

void read_info ()
{
  io_lock (misc_fd, 0, sizeof (info));
  io_read (misc_fd, 0, sizeof (info), info);
  io_unlock (misc_fd, 0, sizeof (info));
}

void init_info ()
{
  io_write (misc_fd, 0, sizeof (info), info);
}

void merge_stats ()
{
  io_lock (misc_fd, O_read, sizeof (I_read));

  io_read (misc_fd, O_read, sizeof (I_read), &I_read);
  I_read += t_read;
  io_write (misc_fd, O_read, sizeof (I_read), &I_read);
  t_read = 0;
  io_read (misc_fd, O_empty, sizeof (I_empty), &I_empty);
  I_empty += t_empty;
  io_write (misc_fd, O_empty, sizeof (I_empty), &I_empty);
  t_empty = 0;
  io_read (misc_fd, O_written, sizeof (I_written), &I_written);
  I_written += t_written;
  io_write (misc_fd, O_written, sizeof (I_written), &I_written);
  t_written = 0;
  io_read (misc_fd, O_added, sizeof (I_added), &I_added);
  I_added += t_added;
  io_write (misc_fd, O_added, sizeof (I_added), &I_added);
  t_added = 0;
  io_read (misc_fd, O_erased, sizeof (I_erased), &I_erased);
  I_erased += t_erased;
  io_write (misc_fd, O_erased, sizeof (I_erased), &I_erased);
  t_erased = 0;
  io_read (misc_fd, O_blasted, sizeof (I_blasted), &I_blasted);
  I_blasted += t_blasted;
  io_write (misc_fd, O_blasted, sizeof (I_blasted), &I_blasted);
  t_blasted = 0;

  io_unlock (misc_fd, O_read, sizeof (I_read));
}
