#ifndef _globals_
#define _globals_

#include <murlib.h>
#include "data.h"

#define Version_x 1
#define Version_y 31

extern struct connection *c;
extern int log_fd, table_fd, data_fd, misc_fd;

extern unsigned long t_read, t_empty, t_written, t_added, t_erased, t_blasted;

/* Contents of the "misc" file. */
/* Read-only */
#define I_max_blocks (info [0])
#define I_num_buckets (info [1])
#define I_ro_x (info [2])
#define I_ro_y (info [3])
#define I_epoch (info [4])
/* Read/Write */
#define O_free_head 5
#define I_free_head (info [O_free_head])
#define O_free_length 6
#define I_free_length (info [O_free_length])
#define O_read 7
#define I_read (info [O_read])
#define O_empty 8
#define I_empty (info [O_empty])
#define O_written 9
#define I_written (info [O_written])
#define O_added 10
#define I_added (info [O_added])
#define O_erased 11
#define I_erased (info [O_erased])
#define O_blasted 12
#define I_blasted (info [O_blasted])
#define O_cur_blocks 13
#define I_cur_blocks (info [O_cur_blocks])
#define Info_size 14
extern unsigned long info [Info_size];

void read_info ();
void init_info ();
void merge_stats ();

#endif /* _globals_ */
