#include <unistd.h>
#include "error.h"

int io_lock (fd, offs, recsz)
  int fd;
  long offs;
  int recsz;
{
  long i;

  lseek (fd, offs * recsz, SEEK_SET);
  for (i = 0; i < 5; i++){
    if (lockf (fd, F_TLOCK, (long) recsz) == 0) goto ok;
    sleep (1);
  }
  log ("io_lock: lock failed; offs = ", offs);
  return 0;
 ok:
  return 1;
}

void io_unlock (fd, offs, recsz)
  int fd;
  long offs;
  int recsz;
{
  lseek (fd, offs * recsz, SEEK_SET);
  lockf (fd, F_ULOCK, (long) recsz);
}

void io_read (fd, offs, recsz, buf)
  int fd;
  long offs;
  int recsz;
  char *buf;
{
  lseek (fd, offs * recsz, SEEK_SET);
  if (read (fd, buf, recsz) != recsz) bug ("io_read");
}

void io_write (fd, offs, recsz, buf)
  int fd;
  long offs;
  int recsz;
  char *buf;
{
  lseek (fd, offs * recsz, SEEK_SET);
  if (write (fd, buf, recsz) != recsz) bug ("io_write");
}
