#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "config.h"
#include "data.h"
#include "globals.h"
#include "io.h"

char *malloc ();

int verbose = 0, lock = 0;

main (argc, argv)
     int argc;
     char *argv [];
{
  if (argc > 1){
    if (!strcmp (argv [1], "-v")){
      verbose = 1;
    }else if (!strcmp (argv [1], "-l")){
      lock = 1;
    }else{
      fprintf (stderr, "usage : murdebug { -v | -l }\n");
      exit (2);
    }
  }
#if 0
  misc_fd = open (Misc_file_name, O_RDWR);
  if (misc_fd < 0) perror ("open misc ");
  read_info ();
  printf ("misc:\n");
  printf ("   num_bricks = %d\n", I_num_bricks);
  printf ("   num_buckets = %d\n", I_num_buckets);
  printf ("   free_head = %x\n", I_free_head);
  printf ("   ro_x = %d; ro_y = %d\n", I_ro_x, I_ro_y);

  table_fd = open (Table_file_name, O_RDWR);
  if (table_fd < 0) perror ("open table ");
  printf ("\ntable:\n");
  for (i = 0; i < I_num_buckets; i++){
    io_read (table_fd, i, sizeof (struct disk_bucket), (char *) b);
    if (verbose){
      if (b->first != Nil) printf ("   bucket %x, first = %x\n", i, b->first);
    }
  }

  index_fd = open (Index_file_name, O_RDONLY);
  if (index_fd < 0) perror ("open index ");
  printf ("\nindex: (used bricks)\n");
  for (i = 0; i < I_num_bricks; i++){
    io_read (index_fd, i, sizeof (struct disk_desc), (char *) d);
    if (d->x != Nil_coord){
      if (verbose){
	      printf ("   desc %x, next = %x, x y = %d %d\n", i, d->next, d->x, d->y);
      }
      ++used;
    }
  }
  printf ("\nThe mur is %d%% full.\n", used * 100 / I_num_bricks);
  printf ("\nindex: (empty bricks)\n");
  for (i = 0; i < I_num_bricks; i++){
    io_read (index_fd, i, sizeof (struct disk_desc), (char*) d);
    if (verbose){
      if (d->x == Nil_coord){
	      printf ("   desc %x, next = %x\n", i, d->next);
      }
    }
  }

  if (lock){
    printf ("Locking files...");
    fflush (stdout);
    lseek (table_fd, 0, SEEK_SET);
    lockf (table_fd, F_LOCK, I_num_buckets * sizeof (struct disk_bucket));
    lseek (misc_fd, 0, SEEK_SET);
    lockf (misc_fd, F_LOCK, sizeof (info));
    printf ("locked.  Sleeping for 100s.\n");
    sleep (100);
  }

  bitmap = malloc (I_num_bricks);
  for (i = 0; i < I_num_bricks; i++) bitmap [i] = 0;

  printf ("Checking the free-list...");
  verify_free_list (bitmap, verbose);
  printf ("\n...done\n");

  {
    long depth, max_depth = 0;

    printf ("Checking the buckets...");
    for (i = 0; i < I_num_buckets; i++){
      lock_bucket (b, i);
      if (verbose) printf ("%x.", i);
      depth = check_bucket (b, bitmap);
      if (depth > max_depth) max_depth = depth;
      unlock_bucket (b);
    }
    printf ("\n...done; max bucket depth = %d\n", max_depth);
  }

  for (i = 0; i < I_num_bricks; i++){
    if (!bitmap [i]) ++rem;
  }
  printf ("%d descriptors are unaccounted for.\n", rem);
#endif
}
