#include "data.h"
#include "pack.h"

/*  Compression algorithm :

   This is an RLE scheme.

   A run of length 3 <= l <= 34 chars c is encoded by  <l-3> c
   A run of length 35 <= l <= 290 spaces is encoded by <DEL> <l-35>

*/

long pack_brick (bl, br)
     block_list_t bl;
     brick_t br;
{
  long i;
  unsigned char buf [1024];
  long cur = 0;
  char *brick = (char *) br;
  long new_length;
  unsigned char last;
  long run_len;

#define Out(c) buf [cur++] = (c);

  for (i = 0; i < 1024; ){
    last = brick [i];
    run_len = 1;
    ++i;
    while (i < 1024 && brick [i] == last){
      ++run_len;
      ++i;
    }
    /* Output a run of chars. */
    if (last == ' '){
      while (run_len > 290){
	Out (127);
	Out (255);
	run_len -= 290;
      }
      if (run_len > 34){
	Out (127);
	Out (run_len - 35);
	run_len = 0;
      }
    }
    while (run_len > 34){
      Out (31);
      Out (last);
      run_len -= 34;
    }
    if (run_len > 2){
      Out (run_len - 3);
      Out (last);
      run_len = 0;
    }
    while (run_len > 0){
      Out (last);
      --run_len;
    }
  }    

  if (cur <= 48){
    new_length = 1;
  }else{
    new_length = 1 + ((cur - 48) + 59) / 60;
  }
  bcopy (buf, Desc (bl)->data, 48);
  for (i = 1; i < new_length; i++){
    bcopy (buf + 48 + (i-1) * 60, bl->blocks [i].data, 60);
  }
    
  return new_length - bl->length;
}

void unpack_brick (res, bl)
     brick_t res;
     block_list_t bl;
{
  unsigned char buf [60 * Blocks_per_brick];
  long i, cur;
  unsigned char c, ch;
  char *result = (char *) res;

  if (bl->length == 0){
    fill_brick (res);
    return;
  }
  bcopy (Desc (bl)->data, buf, 48);
  for (i = 1; i < bl->length; i++){
    bcopy (bl->blocks [i].data, buf + 48 + (i-1) * 60, 60);
  }

#define Expand(n, ch) \
  { long _; for (_ = 0; _ < (n) && i < 1024; _++) { result [i++] = (ch); } }

  cur = 0;
  for (i = 0; i < 1024;){
    c = buf [cur++];
    if (c <= 31){
      ch = buf [cur++];
      Expand (c + 3, ch);
    }else if (c == 127){
      c = buf [cur++];
      Expand (c + 35, ' ');
    }else{
      result [i++] = c;
    }
  }
}
